<script setup>
import { CdxField, CdxRadio, CdxLookup, CdxMultiselectLookup } from '@wikimedia/codex';
import { onBeforeMount, ref, computed } from 'vue'
import { useInstrumentStore } from '../../stores/instrument.js'
import { useStreamStore } from '../../stores/stream.js';

const instrumentStore = useInstrumentStore();
const streamStore = useStreamStore();
const webBaseStreamName = import.meta.env.VITE_METRICS_PLATFORM_WEB_BASE_STREAM_NAME
const appBaseStreamName = import.meta.env.VITE_METRICS_PLATFORM_APP_BASE_STREAM_NAME

onBeforeMount(async () => {
    await streamStore.refreshStreams()
})

// Function for new or existing instrument
const radiosSchemaType = [
    {
        label: 'App base',
        value: 'app'
    },
    {
        label: 'Web base',
        value: 'web'
    },
    {
        label: 'Custom',
        value: 'custom'
    }
];

// Set stream name field as enabled if schema type is custom.
const disableStreamName = computed(() => {
  return instrumentStore.instrument.schema_type === 'custom' ? false : true
})
const disableContextualAttributes = computed(() => {
    return instrumentStore.instrument.schema_type === undefined
})

/**
 * Filter items on input.
 *
 * @param {string} value
 */
 function onChangeStreamName( value ) {
    if ( value ) {
        streamFilter.value = value;
        streamStore.stream.name = value;
    }
}

/**
 * Prepopulate form on input.
 *
 * @param {string} value
 */
 function onStreamSelection( value ) {
    instrumentStore.instrument.stream_name = value
    instrumentStore.instrument.schema_title = streamStore.streamsMap.get(value)
    // Check if selected stream is web or app base and update schema type to match.
    if (value === webBaseStreamName) {
        instrumentStore.instrument.schema_type = 'web'
    }
    if (value === appBaseStreamName) {
        instrumentStore.instrument.schema_type = 'app'
    }
}

/**
 * Set form data for schema related fields
 *
 * @param {string} value
 */
 function onSchemaTypeSelection( value ) {
    // Empty selected contextual attributes if the schema type is different from the previously assigned
    contextualAttributesChips.value = [];
    
    switch(value) {
        case 'app':
            onStreamSelection(appBaseStreamName)
            onChangeStreamName(appBaseStreamName)
            break;
        case 'web':
            onStreamSelection(webBaseStreamName)
            onChangeStreamName(webBaseStreamName)
            break;
        case 'custom':
            instrumentStore.instrument.stream_name = ''
            break;
    }

    instrumentStore.setContextualAttributes();
}

// To populate the stream search dropdown.
const streamFilter = ref( [] );
const menuItems = computed(() => streamStore.streamsMenu.filter( ( item ) => {
    return item.label.toLowerCase().includes( streamFilter.value );
}));
const menuConfig = {
    boldLabel: true
};

// Contextual Attributes section
let contextualAttributes = []
if ((instrumentStore.instrument.contextual_attributes !== undefined) && (instrumentStore.instrument.contextual_attributes !== '')) {
    contextualAttributes = instrumentStore.instrument.contextual_attributes.split(',')
}

const contextualAttributesChips = ref( contextualAttributes.map( item => ({ label: item, value: item})) )
const contextualAttributesSelection = ref( contextualAttributes )
const contextualAttributesMenuItems = ref( [] )

function onContextualAttributesInput( value ) {
    if ( value ) {
        contextualAttributesMenuItems.value = instrumentStore.mappedContextualAttributes.filter(( item ) => 
            item.label.toLowerCase().includes( value.toLowerCase() )
        );
    } else {
        contextualAttributesMenuItems.value = [];
    }
}

function onContextualAttributesChanged ( newSet ) {
    instrumentStore.instrument.contextual_attributes = Array.from(newSet).join(',');
}
</script>

<template>
    <h2>Schema</h2>
    <!-- DETAILS: Schema Type -->
    <cdx-field :is-fieldset="true">
        <template #label>
            Schema Type
        </template>
        <template #description>
            Select a base or custom schema for your instrument. <a class="cdx-docs-link" target="_new" href="https://wikitech.wikimedia.org/wiki/Metrics_Platform/Schemas">Learn more</a>
        </template>
        <cdx-radio
            v-for="radio in radiosSchemaType"
            :key="'radio-' + radio.value"
            v-model="instrumentStore.instrument.schema_type"
            name="radio-group-schema-type"
            :input-value="radio.value"
            @update:model-value="onSchemaTypeSelection"
            data-id="schema-type"
        >
            {{ radio.label }}
            <template #description>
                {{ radio.description }}
            </template>
        </cdx-radio>
    </cdx-field>
    <cdx-field>
        <cdx-lookup
            v-model:selected="instrumentStore.instrument.stream_name"
            :input-value="instrumentStore.instrument.stream_name"
            :menu-items="menuItems"
            :menu-config="menuConfig"
            aria-label="Select a production schema"
            placeholder="Select a production schema"
            @input="onChangeStreamName"
            @update:selected="onStreamSelection"
            :readonly="disableStreamName"
            data-id="stream-name"
        ></cdx-lookup>
        <template #label>
            Stream name
        </template>
        <template #description>
            The instrument's stream is determined by the schema type
        </template>
    </cdx-field>

    <div class="contextual-attributes">
        <!-- SPECIFICATIONS: Contextual attributes -->
        <cdx-field>
            <cdx-multiselect-lookup
                v-model:input-chips="contextualAttributesChips"
                v-model:selected="contextualAttributesSelection"
                :menu-items="contextualAttributesMenuItems"
                data-id="contextual-attributes"
                @input="onContextualAttributesInput"
                @update:selected="onContextualAttributesChanged($event)"
                placeholder="Enter a property"
                :readonly="disableContextualAttributes"
            />
            <template #label>
                Contextual Attributes
            </template>
            <template #description>
                Collect extra information about the users who triggered the event and the wiki where the event occurred.
                <a class="cdx-docs-link" target="_new" href="https://wikitech.wikimedia.org/wiki/Metrics_Platform/Contextual_attributes">Learn more</a>
            </template>
        </cdx-field>
    </div>
</template>

<style scoped>
.column.right {
    margin-top: 20px;
}

.contextual-attributes {
    margin-top: 20px;
}
</style>
